// reduced version of "basic_utils.h"
// might want to put some of this into MCFgen.h
// it's a mess until I've made my personal C++ library

#include <algorithm>  // reverse
#include <vector>

using namespace std;

// reverse complement a matrix
template<class T> void reverse_complement(vector<vector<T> > & mat)
{
  // reverse the columns:
  reverse(mat.begin(), mat.end());

  // reverse each column:
  for (unsigned int k = 0u; k < mat.size(); ++k)
    reverse(mat[k].begin(), mat[k].end());
}

// reverse complement a matrix, putting the result in destination
// makes assumptions about the destination similar to reverse_copy
template<class T> void reverse_complement_copy(const vector<vector<T> > & source, vector<vector<T> > & destination)
{
  // reverse the columns:
  reverse_copy(source.begin(), source.end(), destination.begin());

  // reverse each column:
  for (unsigned int k = 0u; k < source.size(); ++k)
    reverse(destination[k].begin(), destination[k].end());
}

// is the vector equal to its reverse?
/*
template<class T> bool is_reverse(const vector<T> & v)
{
  unsigned int end = v.size() - 1;

  for (unsigned int i = 0u; i < v.size() / 2; ++i)
    if (v[i] != v[end - i])
      return false;

  return true;
}
*/

// is the matrix equal to its reverse complement?
template<class T> bool is_reverse_complement(const vector<vector<T> > & mat)
{
  unsigned int end = mat.size() - 1;

  for (unsigned int i = 0u; i <= mat.size() / 2; ++i) {
    unsigned int end2 = mat[i].size() - 1;
    for (unsigned int j = 0u; j <= end2; ++j)
      if (mat[i][j] != mat[end - i][end2 - j])
	return false;
  }

  return true;
}
